#version 120

#define COLORED_SHADOWS 1
#define SHADOW_BRIGHTNESS 0.75

uniform sampler2D lightmap;
uniform sampler2D shadowcolor0;
uniform sampler2D shadowtex0;
uniform sampler2D shadowtex1;
uniform sampler2D texture;

varying vec2 lmcoord;
varying vec2 texcoord;
varying vec4 glcolor;
varying vec3 shadowPos;

void main() {
    vec4 color = texture2D(texture, texcoord) * glcolor;
    vec2 lm = lmcoord;

    float shadowVal0 = texture2D(shadowtex0, shadowPos.xy).r;
    float shadowVal1 = texture2D(shadowtex1, shadowPos.xy).r;

    #if COLORED_SHADOWS == 0
        if (shadowVal0 < shadowPos.z) {
            lm.y *= SHADOW_BRIGHTNESS;
        }
    #else
        if (shadowVal1 < shadowPos.z) {
            lm.y *= SHADOW_BRIGHTNESS;
        } else {
            lm.y = 31.0 / 32.0;
            
            #if COLORED_SHADOWS == 1
                if (shadowVal0 < shadowPos.z) {
                    vec4 shadowLightColor = texture2D(shadowcolor0, shadowPos.xy);
                    shadowLightColor.rgb = mix(vec3(1.0), shadowLightColor.rgb, shadowLightColor.a);
                    shadowLightColor.rgb = mix(shadowLightColor.rgb, vec3(1.0), lm.x);
                    color.rgb *= shadowLightColor.rgb;
                }
            #endif
        }
    #endif

    color *= texture2D(lightmap, lm);

    gl_FragData[0] = color; // gcolor
}
